/*
 * Copyright (c) BindView Development Corporation, 2001
 * See LICENSE file.
 * Author: Todd Sabin <tsabin@razor.bindview.com>
 */


#define UNICODE
#define _UNICODE
#include <tchar.h>
#include <windows.h>
#include <aclui.h>
#include <aclapi.h>
#include "samr.h"

#pragma comment (lib, "aclui.lib")
#pragma comment (lib, "comctl32.lib")


static SI_ACCESS g_samAccess[] = {
    { &GUID_NULL, 0x00000001,   L"Unknown 0x1", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000002,   L"Shutdown Server", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000004,   L"Unknown 0x4", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000008,   L"Unknown 0x8", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000010,   L"Enum Domains", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000020,   L"Open Domain", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, DELETE,   L"Delete", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, READ_CONTROL, L"Read Control", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, WRITE_DAC,    L"Write DAC", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, WRITE_OWNER,  L"Write Owner", SI_ACCESS_SPECIFIC },

    { &GUID_NULL, 0x00020010,   L"Read", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x0002000e,   L"Write", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x00020021,   L"Execute", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x000f003f,   L"Full Control", SI_ACCESS_GENERAL },
};

static GENERIC_MAPPING g_samGenericMapping = {
    0x20010,
    0x2000e,
    0x20021,
    0xf003f
};

static SI_INHERIT_TYPE g_samInheritTypes[] = {
    { &GUID_NULL,     0, L"This object only" },
};


static SI_ACCESS g_samDomainAccess[] = {
    { &GUID_NULL, 0x00000001,   L"Lookup Info 1", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000002,   L"Set Info 1", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000004,   L"Lookup Info 2", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000008,   L"Set Info 2", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000010,   L"Create User", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000020,   L"Create Group", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000040,   L"Create Alias", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000080,   L"Unknown", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000100,   L"Enum Accts", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000200,   L"Open Acct, Lookup Names", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000400,   L"Set Info 3", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, DELETE,       L"Delete", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, READ_CONTROL, L"Read Control", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, WRITE_DAC,    L"Write DAC", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, WRITE_OWNER,  L"Write Owner", SI_ACCESS_SPECIFIC },

    { &GUID_NULL, 0x00020084,   L"Read", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x0002047a,   L"Write", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x00020301,   L"Execute", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x000f07ff,   L"Full Control", SI_ACCESS_GENERAL },
};

static GENERIC_MAPPING g_samDomainGenericMapping = {
    0x20084,
    0x2047a,
    0x20301,
    0xf07ff
};

static SI_ACCESS g_samUserAccess[] = {
    { &GUID_NULL, 0x00000001,   L"Get Acct Name, Rid, etc.", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000002,   L"Get Locale", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000004,   L"Set Comment, Locale", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000008,   L"Get Logon Info", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000010,   L"Acct Flags, Expiry", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000020,   L"Set Attributes", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000040,   L"Change Password", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000080,   L"Set Password", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000100,   L"Get Groups", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000200,   L"Unknown 0x200", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000400,   L"Unknown 0x400", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, DELETE,       L"Delete", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, READ_CONTROL, L"Read Control", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, WRITE_DAC,    L"Write DAC", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, WRITE_OWNER,  L"Write Owner", SI_ACCESS_SPECIFIC },

    { &GUID_NULL, 0x0002031a,   L"Read", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x00020044,   L"Write", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x00020041,   L"Execute", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x000f07ff,   L"Full Control", SI_ACCESS_GENERAL },
};

static GENERIC_MAPPING g_samUserGenericMapping = {
    0x2031a,
    0x20044,
    0x20041,
    0xf07ff
};

static SI_ACCESS g_samGroupAccess[] = {
    { &GUID_NULL, 0x00000001,   L"Query Info", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000002,   L"Set Info", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000004,   L"Add Member", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000008,   L"Remove Member", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000010,   L"Get Members", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, DELETE,       L"Delete", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, READ_CONTROL, L"Read Control", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, WRITE_DAC,    L"Write DAC", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, WRITE_OWNER,  L"Write Owner", SI_ACCESS_SPECIFIC },

    { &GUID_NULL, 0x00020010,   L"Read", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x0002000e,   L"Write", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x00020001,   L"Execute", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x000f001f,   L"Full Control", SI_ACCESS_GENERAL },
};

static GENERIC_MAPPING g_samGroupGenericMapping = {
    0x20010,
    0x2000e,
    0x20001,
    0xf001f
};

static SI_ACCESS g_samAliasAccess[] = {
    { &GUID_NULL, 0x00000001,   L"Add Member", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000002,   L"Remove Member", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000004,   L"Get Members", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000008,   L"Query Info", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, 0x00000010,   L"Set Info", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, DELETE,       L"Delete", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, READ_CONTROL, L"Read Control", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, WRITE_DAC,    L"Write DAC", SI_ACCESS_SPECIFIC },
    { &GUID_NULL, WRITE_OWNER,  L"Write Owner", SI_ACCESS_SPECIFIC },

    { &GUID_NULL, 0x00020004,   L"Read", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x00020013,   L"Write", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x00020008,   L"Execute", SI_ACCESS_GENERAL },
    { &GUID_NULL, 0x000f001f,   L"Full Control", SI_ACCESS_GENERAL },
};

static GENERIC_MAPPING g_samAliasGenericMapping = {
    0x20004,
    0x20013,
    0x20008,
    0xf001f
};

static ULONG g_extra_flags;

struct CSamObjectSecurityInfoBase : ISecurityInformation
{
    long m_cRefs;
    SAM_HANDLE m_handle;
    const wchar_t* m_pszObjectName;
    const wchar_t* m_pszServerName;
    const wchar_t* m_pszPageTitle;

    CSamObjectSecurityInfoBase (SAM_HANDLE h,
                                const wchar_t* pszObjectName,
                                const wchar_t* pszServerName,
                                const wchar_t* pszPageTitle = 0)
        : m_cRefs (0),
          m_handle (h),
          m_pszObjectName (pszObjectName),
          m_pszServerName (pszServerName),
          m_pszPageTitle (pszPageTitle)  {}
    virtual ~CSamObjectSecurityInfoBase () {}

    STDMETHODIMP QueryInterface (REFIID iid, void** ppv)
    {
        if ((IID_IUnknown == iid) || (IID_ISecurityInformation == iid)) {
            *ppv = static_cast<ISecurityInformation*>(this);
        } else {
            *ppv = 0;
            return E_NOINTERFACE;
        }
        reinterpret_cast<IUnknown*>(*ppv)->AddRef ();
        return S_OK;
    }
    STDMETHODIMP_ (ULONG) AddRef ()
    {
        return ++m_cRefs;
    }
    STDMETHODIMP_ (ULONG) Release ()
    {
        long n = --m_cRefs;
        if (n==0) {
            SamrClose (&m_handle);
            delete this;
        }
        return n;
    }

    STDMETHODIMP GetObjectInformation (SI_OBJECT_INFO* poi)
    {
        poi->dwFlags = (SI_EDIT_OWNER | SI_EDIT_PERMS | SI_ADVANCED | SI_NO_ACL_PROTECT
                        | g_extra_flags);

        poi->hInstance      = GetModuleHandle (NULL);
        poi->pszServerName  = const_cast<wchar_t*> (m_pszServerName);
        poi->pszObjectName  = const_cast<wchar_t*> (m_pszObjectName);
        poi->pszPageTitle   = const_cast<wchar_t*> (m_pszPageTitle);

        if (m_pszPageTitle)
            poi->dwFlags |= SI_PAGE_TITLE;

        return S_OK;
    }

    STDMETHODIMP GetSecurity (SECURITY_INFORMATION ri, void** ppsd, BOOL bDefault)
    {
        PSAM_SD pSD = NULL;
        unsigned char *sdBuff = NULL;
        NTSTATUS rc = SamrQuerySecurity (m_handle, ri, &pSD);
        if (rc < 0) {
            return rc;
        }
        sdBuff = (unsigned char *)LocalAlloc (LMEM_FIXED | LMEM_ZEROINIT,
                                              pSD->Length);
        memcpy (sdBuff, pSD->pSD, pSD->Length);
        *(PSECURITY_DESCRIPTOR **)ppsd = (PSECURITY_DESCRIPTOR *)sdBuff;
        return 0;
    }

    STDMETHODIMP SetSecurity (SECURITY_INFORMATION ri, void* psd)
    {
        SAM_SD sam_sd = { 0, 0 };
        MakeSelfRelativeSD (psd, sam_sd.pSD, &sam_sd.Length);
        sam_sd.pSD = (unsigned char *) calloc (1, sam_sd.Length);
        if (MakeSelfRelativeSD (psd, sam_sd.pSD, &sam_sd.Length)) {
            DWORD rc = SamrSetSecurity (m_handle, ri, &sam_sd);
            if (rc < 0) {
                return rc;
            } else {
                return S_OK;
            }
        } else {
            return HRESULT_FROM_WIN32 (GetLastError ());
        }
        return 0;

    }

    STDMETHODIMP PropertySheetPageCallback (HWND hwnd, UINT msg, SI_PAGE_TYPE pt)
    {
        return S_OK;
    }
};

struct CSamPolicySecurityInfo : CSamObjectSecurityInfoBase
{
    CSamPolicySecurityInfo (SAM_HANDLE hPol, const wchar_t* pszObjectTitle,
                            const wchar_t* pszServerName = 0,
                            const wchar_t* pszPageTitle = 0)
        : CSamObjectSecurityInfoBase (hPol,
                                      pszObjectTitle,
                                      pszServerName,
                                      pszPageTitle)
    {}
    
    ~CSamPolicySecurityInfo()
    {}

    STDMETHODIMP GetAccessRights (const GUID*,
                                  DWORD dwFlags,
                                  SI_ACCESS** ppAccess,
                                  ULONG* pcAccesses,
                                  ULONG* piDefaultAccess)
    {
        *ppAccess = const_cast<SI_ACCESS*> (g_samAccess);
        *pcAccesses = sizeof (g_samAccess) / sizeof (g_samAccess[0]);
        *piDefaultAccess = 0;
        return S_OK;
    }

    STDMETHODIMP MapGeneric (const GUID*, UCHAR* pAceFlags, ACCESS_MASK* pMask)
    {
        MapGenericMask (pMask, const_cast<GENERIC_MAPPING*> (&g_samGenericMapping));
        return S_OK;
    }

    STDMETHODIMP GetInheritTypes (SI_INHERIT_TYPE** ppInheritTypes, ULONG* pcInheritTypes)
    {
        *ppInheritTypes = g_samInheritTypes;
        *pcInheritTypes = sizeof (g_samInheritTypes) / sizeof (g_samInheritTypes[0]);
        return S_OK;
    }

};


struct CSamDomainSecurityInfo : CSamObjectSecurityInfoBase
{
    CSamDomainSecurityInfo (SAM_HANDLE hPol, const wchar_t* pszObjectTitle,
                            const wchar_t* pszServerName = 0,
                            const wchar_t* pszPageTitle = 0)
        : CSamObjectSecurityInfoBase (hPol,
                                      pszObjectTitle,
                                      pszServerName,
                                      pszPageTitle)
    {}
    
    ~CSamDomainSecurityInfo()
    {}

    STDMETHODIMP GetAccessRights (const GUID*,
                                  DWORD dwFlags,
                                  SI_ACCESS** ppAccess,
                                  ULONG* pcAccesses,
                                  ULONG* piDefaultAccess)
    {
        *ppAccess = const_cast<SI_ACCESS*> (g_samDomainAccess);
        *pcAccesses = sizeof (g_samDomainAccess) / sizeof (g_samDomainAccess[0]);
        *piDefaultAccess = 0;
        return S_OK;
    }

    STDMETHODIMP MapGeneric (const GUID*, UCHAR* pAceFlags, ACCESS_MASK* pMask)
    {
        MapGenericMask (pMask, const_cast<GENERIC_MAPPING*> (&g_samDomainGenericMapping));
        return S_OK;
    }

    STDMETHODIMP GetInheritTypes (SI_INHERIT_TYPE** ppInheritTypes, ULONG* pcInheritTypes)
    {
        *ppInheritTypes = g_samInheritTypes;
        *pcInheritTypes = sizeof (g_samInheritTypes) / sizeof (g_samInheritTypes[0]);
        return S_OK;
    }

};

struct CSamUserSecurityInfo : CSamObjectSecurityInfoBase
{
    CSamUserSecurityInfo (SAM_HANDLE hPol, const wchar_t* pszObjectTitle,
                            const wchar_t* pszServerName = 0,
                            const wchar_t* pszPageTitle = 0)
        : CSamObjectSecurityInfoBase (hPol,
                                      pszObjectTitle,
                                      pszServerName,
                                      pszPageTitle)
    {}
    
    ~CSamUserSecurityInfo ()
    {}

    STDMETHODIMP GetAccessRights (const GUID*,
                                  DWORD dwFlags,
                                  SI_ACCESS** ppAccess,
                                  ULONG* pcAccesses,
                                  ULONG* piDefaultAccess)
    {
        *ppAccess = const_cast<SI_ACCESS*> (g_samUserAccess);
        *pcAccesses = sizeof (g_samUserAccess) / sizeof (g_samUserAccess[0]);
        *piDefaultAccess = 0;
        return S_OK;
    }

    STDMETHODIMP MapGeneric (const GUID*, UCHAR* pAceFlags, ACCESS_MASK* pMask)
    {
        MapGenericMask (pMask, const_cast<GENERIC_MAPPING*> (&g_samUserGenericMapping));
        return S_OK;
    }

    STDMETHODIMP GetInheritTypes (SI_INHERIT_TYPE** ppInheritTypes, ULONG* pcInheritTypes)
    {
        *ppInheritTypes = g_samInheritTypes;
        *pcInheritTypes = sizeof (g_samInheritTypes) / sizeof (g_samInheritTypes[0]);
        return S_OK;
    }

};


struct CSamGroupSecurityInfo : CSamObjectSecurityInfoBase
{
    CSamGroupSecurityInfo (SAM_HANDLE hPol, const wchar_t* pszObjectTitle,
                            const wchar_t* pszServerName = 0,
                            const wchar_t* pszPageTitle = 0)
        : CSamObjectSecurityInfoBase (hPol,
                                      pszObjectTitle,
                                      pszServerName,
                                      pszPageTitle)
    {}

    ~CSamGroupSecurityInfo ()
    {}

    STDMETHODIMP GetAccessRights (const GUID*,
                                  DWORD dwFlags,
                                  SI_ACCESS** ppAccess,
                                  ULONG* pcAccesses,
                                  ULONG* piDefaultAccess)
    {
        *ppAccess = const_cast<SI_ACCESS*> (g_samGroupAccess);
        *pcAccesses = sizeof (g_samGroupAccess) / sizeof (g_samGroupAccess[0]);
        *piDefaultAccess = 0;
        return S_OK;
    }

    STDMETHODIMP MapGeneric (const GUID*, UCHAR* pAceFlags, ACCESS_MASK* pMask)
    {
        MapGenericMask (pMask, const_cast<GENERIC_MAPPING*> (&g_samGroupGenericMapping));
        return S_OK;
    }

    STDMETHODIMP GetInheritTypes (SI_INHERIT_TYPE** ppInheritTypes, ULONG* pcInheritTypes)
    {
        *ppInheritTypes = g_samInheritTypes;
        *pcInheritTypes = sizeof (g_samInheritTypes) / sizeof (g_samInheritTypes);
        return S_OK;
    }

};


struct CSamAliasSecurityInfo : CSamObjectSecurityInfoBase
{
    CSamAliasSecurityInfo (SAM_HANDLE hPol, const wchar_t* pszObjectTitle,
                            const wchar_t* pszServerName = 0,
                            const wchar_t* pszPageTitle = 0)
        : CSamObjectSecurityInfoBase (hPol,
                                      pszObjectTitle,
                                      pszServerName,
                                      pszPageTitle)
    {}
    
    ~CSamAliasSecurityInfo ()
    {}

    STDMETHODIMP GetAccessRights (const GUID*,
                                  DWORD dwFlags,
                                  SI_ACCESS** ppAccess,
                                  ULONG* pcAccesses,
                                  ULONG* piDefaultAccess)
    {
        *ppAccess = const_cast<SI_ACCESS*> (g_samAliasAccess);
        *pcAccesses = sizeof (g_samAliasAccess) / sizeof (g_samAliasAccess[0]);
        *piDefaultAccess = 0;
        return S_OK;
    }

    STDMETHODIMP MapGeneric (const GUID*, UCHAR* pAceFlags, ACCESS_MASK* pMask)
    {
        MapGenericMask (pMask, const_cast<GENERIC_MAPPING*> (&g_samAliasGenericMapping));
        return S_OK;
    }

    STDMETHODIMP GetInheritTypes (SI_INHERIT_TYPE** ppInheritTypes, ULONG* pcInheritTypes)
    {
        *ppInheritTypes = g_samInheritTypes;
        *pcInheritTypes = sizeof (g_samInheritTypes) / sizeof (g_samInheritTypes[0]);
        return S_OK;
    }

};


int
_tmain (int argc, TCHAR *argv[])
{
    SAM_HANDLE hSam = 0;
    SAM_HANDLE hDom = 0;
    NTSTATUS rc;
    wchar_t machine[100] = L"127.0.0.1";
    wchar_string pMachine = L"\\";
    SAM_UNICODE_STRING uni_target;
    SAM_UNICODE_STRING *target = NULL;
    wchar_t *strBinding = NULL;
    handle_t samrRpcHandle;
    RPC_STATUS rpcErr;

    TCHAR *dom = NULL;
    TCHAR *user = NULL;
    TCHAR *group = NULL;
    TCHAR *alias = NULL;

    int bBuiltinDom = FALSE;
    HPROPSHEETPAGE hpsp[10];
    ULONG numsheets = 0;
    ULONG desired_access = MAXIMUM_ALLOWED;

    for (int argnum=1; argnum < argc; argnum++) {
        if (argv[argnum][0] == '-') {
            switch (argv[argnum][1]) {

            case 'd':
                dom = argv[++argnum];
                if (_tcsicmp (dom, _T ("Builtin")) == 0)
                    bBuiltinDom = TRUE;
                break;

            case 'u':
                user = argv[++argnum];
                break;

            case 'g':
                group = argv[++argnum];
                break;

            case 'a':
                alias = argv[++argnum];
                break;

            case 's':
                desired_access |= ACCESS_SYSTEM_SECURITY;
                g_extra_flags |= SI_EDIT_AUDITS;
                break;

            case 'p':
                g_extra_flags |= SI_SERVER_IS_DC;
                break;

            default:
                _tprintf (_T ("Unknown option: %s\n"), argv[argnum]);
                return 0;
                break;
            }
        } else {
            wcsncpy (machine, argv[argnum], sizeof (machine) / sizeof (machine[0]));
            machine[sizeof (machine) / sizeof (machine[0])-1] = L'\0';
            uni_target.Length = wcslen (machine) * 2;
            uni_target.MaximumLength = uni_target.Length + 2;
            uni_target.Buffer = machine;
            target = &uni_target;
        }
    }
    
    rpcErr = RpcStringBindingCompose (NULL, L"ncacn_np", machine,
                                      L"\\pipe\\samr", L"", &strBinding);
    if (rpcErr) {
        return rpcErr;
    }

    rpcErr = RpcBindingFromStringBinding (strBinding, &samrRpcHandle);
    if (rpcErr) {
        return rpcErr;
    }

    rc = SamrConnect2 (samrRpcHandle, &pMachine, desired_access, &hSam);
    if (rc < 0) {
        MessageBox (HWND_DESKTOP, L"Failed to open SAM", L"Error", MB_OK);
        return 0;        
    }

    CSamPolicySecurityInfo* psi =
        new CSamPolicySecurityInfo (hSam, L"Sam",
                                    target ? machine : NULL,
                                    L"Sam Object");
    psi->AddRef ();
    hpsp[numsheets++] = CreateSecurityPage (psi);
    psi->Release ();
    psi = NULL;

    if (dom) {
        ULONG resume = 0;
        PSAM_ENUM_DOMAINS pDomains = NULL;
        ULONG num;
        unsigned int i;

        rc = SamrEnumDomains (hSam, &resume, 1000, &pDomains, &num);
        if (rc >= 0) {
            for (i=0; i<num; i++) {
                PSAM_SID pDomSid = NULL;
                wchar_t name_buff[100] = L"";

                if (pDomains->Domains[i].Name.Length + 2 <= sizeof (name_buff)) {
                    memcpy (name_buff, pDomains->Domains[i].Name.Buffer,
                            pDomains->Domains[i].Name.Length);
                    name_buff[pDomains->Domains[i].Name.Length/2] = L'\0';
                }

                if (bBuiltinDom && wcsicmp (name_buff, L"Builtin") != 0) {
                    continue;
                }

                rc = SamrLookupDomain (hSam, &pDomains->Domains[i].Name,
                                       &pDomSid);
                if (rc >= 0) {
                    rc = SamrOpenDomain (hSam, desired_access, pDomSid,
                                         &hDom);
                    if (rc >= 0) {
                        CSamDomainSecurityInfo* psi =
                            new CSamDomainSecurityInfo (hDom,
                                                        L"Domain",
                                                        target ? machine : NULL,
                                                        name_buff);
                        psi->AddRef ();
                        hpsp[numsheets++] = CreateSecurityPage (psi);
                        psi->Release ();
                    }
                }
                break;
            }
        }
    }

    if (user) {
        SAM_UNICODE_STRING uni_user;
        SAM_RIDS rid = { 0 };
        SAM_TRANS_USES Uses = { 0 };
        SAM_HANDLE hUser = 0;

        uni_user.Buffer = user;
        uni_user.Length = wcslen (user) * 2;
        uni_user.MaximumLength = uni_user.Length + 2;
        rc = SamrLookupNames (hDom, 1, &uni_user, &rid, &Uses);
        if (rc >= 0) {
            rc = SamrOpenUser (hDom, desired_access, rid.pRids[0], &hUser);
            if (rc >= 0) {
                CSamUserSecurityInfo *psi =
                    new CSamUserSecurityInfo (hUser,
                                              L"User",
                                              target ? machine : NULL,
                                              user);
                psi->AddRef ();
                hpsp[numsheets++] = CreateSecurityPage (psi);
                psi->Release ();
            }
        }
    }

    if (group) {
        SAM_UNICODE_STRING uni_group;
        SAM_RIDS rid = { 0 };
        SAM_TRANS_USES Uses = { 0 };
        SAM_HANDLE hGroup = 0;

        uni_group.Buffer = group;
        uni_group.Length = wcslen (group) * 2;
        uni_group.MaximumLength = uni_group.Length + 2;
        rc = SamrLookupNames (hDom, 1, &uni_group, &rid, &Uses);
        if (rc >= 0) {
            rc = SamrOpenGroup (hDom, desired_access, rid.pRids[0], &hGroup);
            if (rc >= 0) {
                CSamGroupSecurityInfo *psi =
                    new CSamGroupSecurityInfo (hGroup,
                                              L"Group",
                                              target ? machine : NULL,
                                              group);
                psi->AddRef ();
                hpsp[numsheets++] = CreateSecurityPage (psi);
                psi->Release ();
            }
        }
    }

    if (alias) {
        SAM_UNICODE_STRING uni_alias;
        SAM_RIDS rid = { 0 };
        SAM_TRANS_USES Uses = { 0 };
        SAM_HANDLE hAlias = 0;

        uni_alias.Buffer = alias;
        uni_alias.Length = wcslen (alias) * 2;
        uni_alias.MaximumLength = uni_alias.Length + 2;
        rc = SamrLookupNames (hDom, 1, &uni_alias, &rid, &Uses);
        if (rc >= 0) {
            rc = SamrOpenAlias (hDom, desired_access, rid.pRids[0], &hAlias);
            if (rc >= 0) {
                CSamAliasSecurityInfo *psi =
                    new CSamAliasSecurityInfo (hAlias,
                                              L"Alias",
                                              target ? machine : NULL,
                                              alias);
                psi->AddRef ();
                hpsp[numsheets++] = CreateSecurityPage (psi);
                psi->Release ();
            }
        }
    }

    PROPSHEETHEADER psh = { sizeof (psh) };
    psh.hInstance = GetModuleHandle (NULL);
    psh.pszCaption = L"SAM Acl Editor";
    psh.nPages = numsheets;
    psh.phpage = hpsp;

    PropertySheet (&psh);

    return 0;
}



void  __RPC_FAR * __RPC_USER
midl_user_allocate (size_t len)
{
    return malloc (len);
}

void __RPC_USER
midl_user_free (void __RPC_FAR * ptr)
{
    free (ptr);
}
